<?php
use LabBase\Model\Brand;
use LabBase\Model\BrandPost;
use LabBase\Model\Category;
use LabBase\Model\User;

$brandBannerChangeURL = $this->url('root/brandSettings', ['action' => 'uploadBanner', 'param' => $this->thisBrand->url]);

$thisBrandLogoURL = \LabBase\Model\ImageSaver::GetImageS3LinkFromName('brand-avatar-'.$this->thisBrand->id);
$thisBrandURL = $this->url('root/brandFeed', ['brandUrl' => $this->thisBrand->url]);

/** @var $user User */
$user = $this->sessionInfo()->getLoggedInUser();
?>

<script>
    var g_thisBrand = {
        id: <?= $this->thisBrand->id; ?>,
        name: '<?= addslashes($this->thisBrand->name); ?>',
        category: '<?= addslashes($this->categoryUrl); ?>',
        url: '<?= addslashes($this->thisBrand->url); ?>',
        loveCount: <?= $this->thisBrand->loveCount; ?>,
        lovedByUser: <?= $this->brandLovedByUser ? 'true' : 'false' ?>
    };
    <?php if($user) { ?>

    var g_loggedInUser = {
        id: <?= $user->id; ?>,
        name: '<?= addslashes($user->fullName) ?>',
        isAdmin: <?= $user->isAdmin() ? 'true' : 'false'  ?>,
        canEditBrand: <?= $this->userCanEditBrand ? 'true' : 'false' ?>
    };
    <?php }else{ ?>
    var g_loggedInUser = false;
    <?php } ?>
</script>

<?php


$brandName = null;
if($this->BrandName) {
    $brandName = $this->BrandName;
    $brandUrl = $this->BrandUrl;
    $brandDescription = $this->BrandDescription;
}else{
    if ($user && $user->lastVisitedBrandId !== null) {
        /** @var Brand $brand */
        $brand = $this->sessionInfo()->getBrandById($user->lastVisitedBrandId);
        if ($brand) {
            $brandName = $brand->name;
            $brandDescription = $brand->description;
            $brandUrl = $brand->url;
        }
    }
    else{
        $brandName = $this->thisBrand->name;
        $brandDescription = $this->thisBrand->description;
        $brandUrl = $this->thisBrand->url;
    }
}
$thisBrand = $this->thisBrand;
?>


<iframe id="editorImageSubmitterIframe" name="editorImageSubmitterIframe" style="display: none;" onload="if(this.contentWindow.location.href != 'about:blank' && window.imageUploadSubmitted) {window.imageUploadSubmitted(this)}"> </iframe>
<form onsubmit="window.imageUploadStarted()" enctype="multipart/form-data" method="post" target="editorImageSubmitterIframe" action="<?= $this->url('root/brandServiceAddImage', ['brandUrl' => $brandUrl]); ?>">
    <input type="file" name="image" style="display: none" id="editorImageSubmitter" onchange="$(this).parent().submit()" />
</form>
<script>
    window.imageUploadStarted = function() {
        window.postImageUploadFinished = window.loadingIndicator($('body')); 
    };
    window.imageUploadEnded = function() {
        if (window.postImageUploadFinished) {
            window.postImageUploadFinished();
        }
    };

    window.imageSubmittedCallback = false;
    window.imageUploadSubmitted = function(el) {
        window.imageUploadEnded();

        if(window.imageSubmittedCallback === false) return;
        var iframeContents = $(el)[0].contentDocument.body.innerHTML;

        var re = /\{[\-a-zA-Z"'0-9:\w|.,/\\]+\}/.exec(iframeContents);
        if(re == null) {
            labAlert("An error has occured while uploading the photo.");
            window.imageSubmittedCallback(false);
            window.imageSubmittedCallback = false;
            return;
        }
        var response = re[0];
        response = JSON.parse(response);
        console.log("Successfully uploaded image:", response);
        window.imageSubmittedCallback(response.imageLink);
        window.imageSubmittedCallback = false;
    };
</script>


<!-- Header -->
    <?php echo $this->render('brand-header.phtml', array('user' => $user, 'thisBrand' => $this->thisBrand, 'draftspostCnt' => $this->draftspostCnt, 'brandName' => $brandName, 'thisBrandLogoURL' => $thisBrandLogoURL, 'userCanEditBrand' => $this->userCanEditBrand)); ?>
<!--END-->

<div class="body-content about_us_page">
   
    <div class="wrapper">
       
        <!-- Intro -->
        <?php echo $this->render('brand-body-top.phtml', array('user' => $user, 'thisBrand' => $this->thisBrand, 'draftspostCnt' => $this->draftspostCnt, 'brandName' => $brandName, 'thisBrandLogoURL' => $thisBrandLogoURL, 'userCanEditBrand' => $this->userCanEditBrand)); ?>
        <!--END-->

        <!-- Sidebar Layout -->
        <div class="sidebar-layout">
            <?php echo $this->render('band-menu.phtml', array('page' => 'about', 'brandUrl' => $this->thisBrand->url)); ?>
            
            <!-- Main Content -->
            <div class="main-content">
            
                <div class="panel panel-default about_us_section">
                    
                    <div class="panel-heading">
                        <ul class="aboutus_header">
                            <li class="active">
                                <a href="<?php echo $this->url('root/brandAbout', ['brandUrl' => $this->brandUrl]); ?>">About Us</a>
                            </li>
                            <li>
                                <a href="<?php echo $this->url('root/brandManagementTeam', ['brandUrl' => $this->brandUrl]); ?>"><?php echo $this->managementTeamName; ?></a>
                            </li>
                        </ul>
                    </div>
                    
                    <div class="panel-body">
                        <?php if(!empty($this->aboutLists)){ ?>
                            <ol class="aboutus_container" id="aboutus_list">
                            <?php foreach($this->aboutLists as $aboutList){ ?>
                                    <li id="about_data_<?php echo $aboutList->id; ?>" class="about_data_container" data-id="<?php echo $aboutList->id; ?>">
                                        <?php if($this->userCanEditBrand){ ?>
                                            <div class="dropdown about-actions">
                                                <a href="#" class="dropdown-toggle" aria-expanded="false" data-toggle="dropdown">
                                                    <i class="fa fa-pencil" aria-hidden="true"></i>
                                                </a>
                                                <ul class="dropdown-menu dropdown-menu-right">
                                                    <li>
                                                        <a href="javascript: void(0);" data-id="<?php echo $aboutList->id; ?>" onclick="editAboutPopup(this);">
                                                            Edit
                                                        </a>
                                                    </li>
                                                    <li>
                                                        <a href="<?php echo $this->url("root/brandDeleteAbout", ["aboutId" => $aboutList->id]); ?>" onclick="javascript: deleteAbout($(this)); return false;" data-id="<?php echo $aboutList->id; ?>">
                                                            Delete
                                                        </a>
                                                    </li>
                                                </ul>
                                            </div>
                                        <?php } ?>
                                        <h3><?php echo $aboutList->aboutTitle; ?></h3>
                                        <p><?php echo $aboutList->aboutDescription; ?></p>
                                        <?php if($this->userCanEditBrand){ ?>
                                            <span class="my-handle"><i class="fa fa-arrows-v fa-4x" aria-hidden="true"></i></span>
                                        <?php } ?>
                                    </li>
                            <?php } ?>
                            </ol>
                        <?php } ?>
                        
                        <?php if($this->userCanEditBrand){ ?>
                        <div class="aboutus_add">
                            <?php 
                                $addAboutText = ($this->aboutHeaderIndex == 0) ? "Add ".$this->aboutHeaderTitle : 
                                    ($this->aboutHeaderIndex > 0) ? "Add ".str_replace("Our", 'Your', $this->aboutHeaderTitle) : "Add Something About Us";
                            ?>
                            <a href="javascript:void(0);" onclick="javascript: displayAddFrom(this);">
                                <i class="icon-plus"></i> <?php echo $addAboutText; ?>
                            </a>
                        </div>
                        
                        <div class="aboutus_add_form">
                            <div class="form-group">
                                <?php 
                                    $descPlaceHolder = ($this->aboutHeaderIndex == 0) ? "Description about ".strtolower($this->aboutHeaderTitle) : 
                                        ($this->aboutHeaderIndex > 0) ? "Description about ".strtolower($this->aboutHeaderTitle) : "Description about us";
                                    $title  = ($this->aboutHeaderIndex == 0) ? "Aditional title" : $this->aboutHeaderTitle;
                                ?>
                                <input type="text" class="form-control aboutus_title" id="aboutus_title" placeholder="Title e.g <?php echo $title; ?>">
                                <textarea placeholder="<?php echo $descPlaceHolder; ?>" id="aboutus_description" class="textarea-scrollbar scrollbar-outer aboutus_description form-control" onblur="javscript: addAboutUs();"></textarea>
                                <input type="hidden" name="hdnAboutHeader" id="hdnAboutHeader" value="<?php echo $this->aboutHeaderTitle; ?>" />
                            </div>
                        </div>
                        <?php } ?>
                        
                    </div>
                </div>
               
            </div>
            <!-- Sidebar -->
            <div class="sidebar">
                <div class="hidden-xs">

                    <div class="section menu-edit hide-by-default">
                        <!-- CATEGORIES DISABLED todo: remove -->
                        <ul id="categories-menu" class="open"> </ul>
                    </div>

                    <div class="brand-info section">
                        <div class="head">
                            <a href="#" onclick="changeBrandAvatar(); return false;" title="Change avatar">
                                <img class="avatar-cont" src="<?= $thisBrandLogoURL; ?>" alt="Logo" />
                            </a>
                            <h6><?= $brandName ?></h6>
                        </div>
                        <div class="item">
                            <input type="text" id="brandShortDescriptionField" class="optional-text-field"
                                placeholder="Brand Info - e.g. location, description">
                        </div>
                    </div>

                    
                </div>
            </div>
        
        </div>
        
        
    </div>
    
</div>

<!-- Footer -->
    <?php echo $this->render('brand-footer.phtml', array('user' => $user, 'thisBrand' => $this->thisBrand, 'draftspostCnt' => $this->draftspostCnt, 'brandName' => $brandName, 'thisBrandLogoURL' => $thisBrandLogoURL)); ?>
<!--END-->

<input type="hidden" value="<?php echo $this->postType; ?>" name="hdnPostType" id="hdnPostType" />
<script src="//cdnjs.cloudflare.com/ajax/libs/Sortable/1.4.2/Sortable.min.js"></script>

<script>

    function calculateDates() {
        var postType = document.getElementById('hdnPostType').value;
        var elements = document.querySelectorAll("[data-date]");
        for(var el in elements) {
            if(!elements.hasOwnProperty(el)) continue;
            el = elements[el];
            if(postType == 'drafts')
            {
                el.innerHTML = 'saved '+formatAgoTime(el.dataset.date);
            }
            else
            {
                el.innerHTML = formatAgoTime(el.dataset.date);
            }
        }
    }
    window.setInterval(calculateDates, 1000 * 29);
    window.onGloabalJS.push(calculateDates);

    <? if($user) { ?>
    window.onGloabalJS.push(function() {
        window.getNotifications('feed-template');
    });
    <? } ?>

    function updateLoveUsButton() {
        if(g_thisBrand.lovedByUser) {
            $('#loveUsButton .text').text('Loved!');
        }else{
            $('#loveUsButton .text').text('Love Us');
        }
    }

    window.loveUsClicked = function(el) {
        var loveBool = !g_thisBrand.lovedByUser;
        window.ajaxSubmitCheck("<?= $this->url("root/interactionController", ["action" => "loveBrand", "param" => $this->thisBrand->id, "param2" => "BOOL"]) ?>".replace(/BOOL/, loveBool), {}, function (data) {
            g_thisBrand.lovedByUser = data.newValue;
            updateLoveUsButton();
        }, "Could not love the brand. %s");
    };
    onGloabalJS.push(updateLoveUsButton);

    function changeBrandAvatar() {
        <?php if($this->userCanEditBrand) { ?>
        labImage('Change brand avatar image', function(imageData) {
            if(imageData) {
                $('.loading-container').show();
                window.ajaxSubmitCheck('<?= $this->url('root/brandSettings', ['action'=>'uploadAvatar', 'param' => $this->thisBrand->url]) ?>', {
                    imageString: imageData.data.split('base64,', 2)[1]
                }, function() {
                    document.location.reload();
                }, "The brand avatar couldn't be changed. %s");
            }
        }, 400, 400);
        <?php }else{ ?>
        return false;
        <?php } ?>
    }    
    
    /*************************************************************************************/
    
    function displayAddFrom(obj)
    {
        $(obj).parent().hide('slow', function(){
            $('.aboutus_add_form').slideDown('slow');
        });
    }
    
    function editAboutUs()
    {
        var titleField = $('#aboutEditPopup .aboutus_title');
        var contentField = $('#aboutEditPopup textarea.aboutus_description');
        var header = $('#aboutEditPopup #hdnAboutHeader').val();
        var id = $('#aboutEditPopup #hdnAboutId').val();
        
        if((titleField.length && titleField.val().trim().length < 1) || contentField.val().trim().length < 1)
        {
            labAlert("Please fill in the title and description before submitting the about us.");
            return;
        }
        
        window.loadingIndicator($('body'));
        
        ajaxSubmit('/$brandAboutEdit/'+g_thisBrand.url , {
            'title': titleField.val().trim(),
            'content': contentField.val().trim(),
            'header': header,
            'aboutId': id,
        }, function(data) {
            if(!data || !data.status || data.status != 'ok') {
                console.log("error:", data);
                var error = "Please try again later or contact the support team.";
                if(data && data.status) error = data.status;
                labAlert("An error has occured while submitting the about us. " + error);
            }else{
                console.log("about us submitted", data);
               
                var msg = 'About us submitted successfully.';
                var dataContent = data.aboutData;
                $('#about_data_'+id+" h3").html(dataContent.aboutTitle);
                $('#about_data_'+id+" p").html(dataContent.aboutDescription);
                $('#aboutEditPopup .close').trigger('click');
                $('.loading-indicator-background').remove();
            }
        });
    }
    
    function addAboutUs()
    {
        var titleField = $('.aboutus_add_form #aboutus_title');
        var contentField = $('.aboutus_add_form #aboutus_description');
        var header = $('.aboutus_add_form #hdnAboutHeader').val();
        
        if((titleField.length && titleField.val().trim().length < 1) || contentField.val().trim().length < 1)
        {
            labAlert("Please fill in the title and description before submitting the about us.");
            return;
        }
        
        window.loadingIndicator($('body'));
        
        ajaxSubmit('/$aboutAdd/'+g_thisBrand.url , {
            'title': titleField.val().trim(),
            'content': contentField.val().trim(),
            'header': header,
        }, function(data) {
            if(!data || !data.status || data.status != 'ok') {
                console.log("error:", data);
                var error = "Please try again later or contact the support team.";
                if(data && data.status) error = data.status;
                labAlert("An error has occured while submitting the about us. " + error);
            }else{
                console.log("about us submitted", data);
               
                var msg = 'About us submitted successfully.';
                var dataContent = data.aboutUS;
                var html = '<li id="about_data_'+dataContent.id+'" class="about_data_container" data-id="'+dataContent.id+'">'+
                                '<div class="dropdown about-actions">'+
                                    '<a data-toggle="dropdown" aria-expanded="false" class="dropdown-toggle" href="#">'+
                                        '<i aria-hidden="true" class="fa fa-pencil"></i>'+
                                    '</a>'+
                                    '<ul class="dropdown-menu dropdown-menu-right">'+
                                        '<li>'+
                                            '<a onclick="editAboutPopup(this);" data-id="'+dataContent.id+'" href="javascript: void(0);">'+
                                                'Edit'+
                                            '</a>'+
                                        '</li>'+
                                        '<li>'+
                                            '<a data-id="'+dataContent.id+'" onclick="javascript: deleteAbout($(this)); return false;" href="/$brandAboutDelete/'+dataContent.id+'">'+
                                                'Delete'+
                                            '</a>'+
                                        '</li>'+
                                    '</ul>'+
                                '</div>'+
                                '<h3>'+dataContent.aboutTitle+'</h3>'+
                                '<p>'+dataContent.aboutDescription+'</p>'+
                                '<span class="my-handle"><i class="fa fa-arrows-v fa-4x" aria-hidden="true"></i></span>'+
                            '</li>';
                
                $('.loading-indicator-background').remove();
                
                $('.aboutus_add_form').slideUp('slow', function(){
                    $('#aboutus_list').append(html);
                    
                    var myText = data.headerTitle;
                    var addAboutText = (data.headerIndex == 0) ? "Add "+data.headerTitle : 
                                    (data.headerIndex > 0) ? "Add "+myText.replace("Our", 'Your') : "Add Something About Us";
                    
                    $('.aboutus_add a').html('<i class="icon-plus"></i> '+addAboutText);
                    $('.aboutus_add').show();
                    
                    var descPlaceHolder = (data.headerIndex == 0) ? "Description about "+myText.toLowerCase() : 
                                        (data.headerIndex > 0) ? "Description about "+myText.toLowerCase() : "Description about us";
                    var title  = (data.headerIndex == 0) ? "Aditional title" : data.headerTitle;
                    titleField.val("");
                    titleField.attr("placeholder", 'Title e.g '+title);
                    contentField.val("");
                    contentField.attr("placeholder", descPlaceHolder);
                    $('.aboutus_add_form #hdnAboutHeader').val(data.headerTitle);
                    //window.location.href = window.location.href;
                });
            }
        });
    }
    
    function updateAboutUsData(jsonString)
    {
        window.loadingIndicator($('body'));
        ajaxSubmit('/$aboutUpdateOrder/'+g_thisBrand.url , {
            'sortOrders': jsonString,
        }, function(data) {
            if(!data || !data.status || data.status != 'ok') {
                console.log("error:", data);
                var error = "Please try again later or contact the support team.";
                if(data && data.status) error = data.status;
                labAlert("An error has occured while updating order. " + error);
            }else{
                console.log("about us order updated");
                
                $('.loading-indicator-background').remove();
            }
        });
    }
    
    function deleteAbout($el)
    {
        labConfirm("Do you really want to delete this about us data?\nThis cannot be undone!", "Are you sure?", function(response) {
            if(response) {
                $el.blur();
                window.loadingIndicator($('body'));
                
                ajaxSubmit($el.attr('href'), {}, function (data) {
                if (!data.status || data.status != "ok") {
                    console.log("openAjaxLink error: ", data);
                    alert(data.status ? data.status : "An error has occurred, please try again.");
                } else {
                    $('#about_data_'+$el.data('id')).slideUp('slow', function(){ $(this).remove();  });
                    $('.loading-indicator-background').remove();
                }
            });
            return false;
            }
        }, "Delete", "Cancel");
    }
    
    function editAboutPopup(obj)
    {
        var aboutId = $(obj).data('id');
        
        window.loadingIndicator($('body')); 
        $('#aboutEditPopup').remove();
        ajaxSubmit('/$brandAboutPopup/' + aboutId, {'aboutId' : aboutId}, function(data) {
                $('body').append(data);
               
                $('#aboutEditPopup .aboutus_description').scrollbar();
                $('#aboutEditPopup').modal('show');
                $('.loading-indicator-background').remove();
        });
        
    }
    
    
    var el = document.getElementById('aboutus_list');
        var sortable = Sortable.create(el,{
            handle: ".my-handle",
            animation: 100,
            onUpdate: function (/**Event*/evt) {
                var itemEl = evt.item;  // dragged HTMLElement
                var indesxes = [];
                $(el).children('li').each(function(){
                    indesxes.push({"id" : $(this).data('id')});
                })
                var jsonString = JSON.stringify([indesxes], null, ' ');
                updateAboutUsData(jsonString);
                // + indexes from onEnd
            },
        });
    /*************************************************************************************/
    
    console.log("REG ONLOAD");
    window.onload = function() {
        console.log("FIRE ONLOAD");
       
       $(document).on('mouseover', '.small-image-section .img-container', function(e) {
            e.preventDefault();
            var $this = $(this);
            var $panel = $('.img-panel', $this);
            if($panel.closest('.small-image-section').hasClass('editable')) {
                var type = $panel.closest('.small-image-section').data('type');
                $panel.toggleClass('active');
                if($panel.hasClass('active')) {
                    $('.img-panel', $this.parent().parent()).removeClass('active');
                    $panel.addClass('active');
                }
                if ($panel.hasClass('new')) {
                    $panel.removeClass('new');
                    $panel.html('<div class="buttons"><button type="button" onclick="removeImageClicked(this, \''+type+'\');" class="icon-close"></button></div>');
                }
            }
        });
        
       $(document).on('click', '.small-image-section .img-container', function(e) {
            e.preventDefault();
            var $this = $(this);
            var $panel = $('.img-panel', $this);
            if($panel.closest('.small-image-section').hasClass('editable')) {
                var type = $panel.closest('.small-image-section').data('type');
                $panel.toggleClass('active');
                if($panel.hasClass('active')) {
                    $('.img-panel', $this.parent().parent()).removeClass('active');
                    $panel.addClass('active');
                }
                if ($panel.hasClass('new')) {
                    $panel.removeClass('new');
                    $panel.html('<div class="buttons"><button type="button" onclick="removeImageClicked(this, \''+type+'\');" class="icon-close"></button></div>');
                }
            }
        });
       
       if($('.service_container .upload-image-list-service div.img-row').length > 0)
        {
            $('.service_container .upload-image-list-service').show();
            $('.service_container .service_add_photo_icon').hide();
        }
       
        var $textareas = $('textarea.autoresize');

        // Comments
        window.autosizeTextarea($('.comment-form textarea.comment-content'), 60, 300);
        window.autosizeTextarea($textareas, 80, 1000); // todo: fix
    }
   
</script>


